use Lab::Moose;
use Lab::Moose::Countdown;
use 5.010;


use Time::HiRes qw/time/;

#my $current_to_field_factor_z = 13.919;
my $voltage_gain_femto = 10000;


my @temperatures 	= (	1.35, 1.5, 1.8, 2.1, 2.4,	2.7,	3,	3.2, 	3.4, 	3.6, 	3.8, 	3.9, 4, 4.05,	4.1, 4.15,	4.2, 4.25,	4.3, 4.325, 4.35,	4.375, 4.4, 4.410, 4.420, 4.430, 4.440, 4.45, 4.46, 4.47, 4.48, 4.485, 4.486, 4.487, 4.488, 4.489, 4.49, 4.491, 4.492, 4.493, 4.494, 4.495, 4.496, 4.497, 4.498, 4.499,	4.5, 4.501, 4.502, 4.503, 4.504, 4.505, 4.506, 4.507, 4.508, 4.509, 4.51, 4.511, 4.512, 4.513, 4.514, 4.515, 4.516, 4.517, 4.518, 4.519, 4.52, 4.525, 4.53, 4.535, 4.54, 4.545, 4.55, 4.575,4.6, 4.7, 4.8, 4.9, 5, 5.1, 5.2, 5.3, 5.4, 5.5, 6, 6.5, 7, 7.5, 8,8.5,9);
#my @temperatures 	= (	 4.55, 4.575,4.6, 4.7, 4.8, 4.9, 5, 5.1, 5.2, 5.3, 5.4, 5.5, 6, 6.5, 7, 7.5, 8,8.5,9);
#my @temperatures 	= (	4.4, 4.41, 4.42, 4.43, 4.44, 4.45, 4.46, 4.47, 4.48, 4.49,4.5, );
#my @temperatures = (4.4);


my @magfields_up_low = linspace(from=>-7.81e-3, to => -7.9e-3, step => 2e-5);
my @magfields_down_low = linspace(from=>-7.74e-3, to => -7.7e-3, step => 2e-5);
my @magfields_up_high = linspace(from=>-8e-3, to => -8.9e-3, step => 3e-4);
my @magfields_down_high = linspace(from=>-8e-3, to => -7.1e-3, step => 3e-4);

my @magfields = (@magfields_down_low,@magfields_up_high,@magfields_down_high);

my $pre_resistor = 1e5;

my $num_sheets = 200;

my $iv_time = 10; # 1 second per IV
my $num_readings = 500; # 10000 points per IV
my $max_yoko_level = 10; # ramp voltageoutputCur from 0 to $max_voltageoutputCur_level
my $sample_time = $iv_time / $num_readings; # 1 ms
my $nplc = 1;
my $sleep_time = 60;





# my $datafile = datafile(folder => $folder, filename => 'data.dat',
                        # columns => [qw/T time current voltage/]);

my $lakeshore = instrument(
    type => 'Lakeshore340',
    connection_type => 'VISA::GPIB',
    connection_options => {pad => 12},
     
    input_channel => 'B', # set default input channel for all method calls
    );

say $lakeshore->idn();
my $T = $lakeshore->get_T(channel => 'B');
say "Sample temp: ", $T;



my $voltageoutputCur = instrument(
    type => 'YokogawaGS200',
    connection_type => 'VISA::GPIB',
    connection_options => {gpib_address => 5},
    # mandatory protection settings
    max_units_per_step => 10,
    max_units_per_second => 10,
    min_units => -32,
    max_units => 32,
    );
say $voltageoutputCur->idn();

my $voltageoutputMag = instrument(
    type => 'YokogawaGS200',
    connection_type => 'VISA::GPIB',
    connection_options => {gpib_address => 1},
    # mandatory protection settings
    max_units_per_step => 10,
    max_units_per_second => 10,
    min_units => -32,
    max_units => 32,
    );
say $voltageoutputMag->idn();







my $highmm = instrument(
    type => 'Agilent34410A',
    connection_type => 'VISA_GPIB',
	  connection_options => {pad => 14},
    );

say $highmm->idn();


my $curmm = instrument(
    type => 'Agilent34410A',
    connection_type => 'VISA_GPIB',
	  connection_options => {pad => 23},
    );

say $highmm->idn();

# say $dmm->idn();
# $dmm->write(command => 'SENS:VOLT:ZERO:AUTO OFF'); # disable auto zero alogrithm
# $dmm->sense_range(value => 10); # ensure manual range

# trigger setup
# $dmm->sense_nplc(value => 0.06);
# $dmm->write(command => "SAMP:COUN  $num_readings"); # measure 25000 points
# $dmm->write(command => 'SAMP:SOUR TIM'); # defined time between samples
# $dmm->write(command => "SAMP:TIM $sample_time");
# $dmm->write(command => 'TRIG:SOUR EXT'); # external 
# $dmm->write(command => 'TRIG:COUN 1'); # accept 1 trigger and go to idle again
# $dmm->write(command => 'TRIG:DELAY 0'); 
# $dmm->write(command => 'FORM:DATA REAL,64');
# $dmm->write(command => 'FORM:BORD NORM');

# say "sampling time: ", $dmm->query(command => "SAMP:TIM?");


# $yoko->write( command => 'PROG:REP 0');
# $yoko->write( command => "PROG:INT $iv_time" ); # program interval
# $yoko->write( command => "PROG:SLOP $iv_time"); # proram slope time 
# $yoko->write( command => 'PROG:EDIT:STAR'); # start editing points
# $yoko->write( command => "SOUR:LEV $max_yoko_level"); # source level point
# $yoko->write( command => 'PROG:EDIT:END' );
# $yoko->set_level(value => 0);
# my $t0 = time();

# for my $temperature (@temperatures) {
    # say "T = $temperature";
    # $lakeshore->set_T(value => $temperature);
    # my $T_set = $lakeshore->get_value(channel=>'B');
    # $yoko->set_level(value => 0);
    # $dmm->write(command => 'INIT');
    # countdown($sleep_time);
    # # do sweep
    # $yoko->write(command => 'PROG:RUN');
    # my $data = $dmm->binary_query(command => 'FETC?', read_length => $num_readings * 8 + 10, timeout => 5);
    # $data = substr($data, 2);
    # $data =~ s/\n$//;
    # my @readings = unpack('d>*', $data);
    # say "number of readings: ", (@readings + 0);
    # my @voltages = map {$_ / $voltage_gain_femto} @readings;
    # my @currents = map {$_ * $max_yoko_level / ($num_readings * $pre_resistor)} (1..$num_readings);
    # $datafile->log_block(
	# prefix => {T => $T_set,  time => time() - $t0},
	# block => [\@currents, \@voltages],
	# add_newline => 1,
	# );
# }


# $yoko->set_level(value => 0);


$highmm->write(command => 'SENS:VOLT:ZERO:AUTO OFF'); # disable auto zero alogrithm
$highmm->sense_range(value => 10); # ensure manual range
$curmm->write(command => 'SENS:VOLT:ZERO:AUTO OFF'); # disable auto zero alogrithm
$curmm->sense_range(value => 10); # ensure manual range






# trigger setup
$highmm->sense_nplc(value => $nplc);
$highmm->write(command => "SAMP:COUN  $num_readings"); # measure 25000 points
$highmm->write(command => 'SAMP:SOUR TIM'); # defined time between samples
$highmm->write(command => "SAMP:TIM $sample_time");
$highmm->write(command => 'TRIG:SOUR EXT'); # external 
$highmm->write(command => 'TRIG:COUN 1'); # accept 1 trigger and go to idle again
$highmm->write(command => 'TRIG:DELAY 0'); 
$highmm->write(command => 'FORM:DATA REAL,64');
$highmm->write(command => 'FORM:BORD NORM');

say "sampling time: ", $highmm->query(command => "SAMP:TIM?");
say "format:data :", $highmm->query(command => 'FORM:DATA?');

# trigger setup
$curmm->sense_nplc(value => $nplc);
$curmm->write(command => "SAMP:COUN  $num_readings"); # measure 25000 points
$curmm->write(command => 'SAMP:SOUR TIM'); # defined time between samples
$curmm->write(command => "SAMP:TIM $sample_time");
$curmm->write(command => 'TRIG:SOUR EXT'); # external 
$curmm->write(command => 'TRIG:COUN 1'); # accept 1 trigger and go to idle again
$curmm->write(command => 'TRIG:DELAY 0'); 
$curmm->write(command => 'FORM:DATA REAL,64');
$curmm->write(command => 'FORM:BORD NORM');

say "sampling time: ", $curmm->query(command => "SAMP:TIM?");


$voltageoutputCur->write( command => 'PROG:REP 0');
$voltageoutputCur->write( command => "PROG:INT $iv_time" ); # program interval
$voltageoutputCur->write( command => "PROG:SLOP $iv_time"); # proram slope time 
$voltageoutputCur->write( command => 'PROG:EDIT:STAR'); # start editing points
#$voltageoutputCur->write( command => "SOUR:LEV 1"); # source level point 
#$voltageoutputCur->write( command => "SOUR:LEV 10"); # source level point
#$voltageoutputCur->write( command => "SOUR:LEV 0.05"); # source level point
#$voltageoutputCur->write( command => "SOUR:LEV 0.1"); # source level point
#$voltageoutputCur->write( command => "SOUR:LEV 0.5"); # source level point
#$voltageoutputCur->write( command => "SOUR:LEV 1"); # source level point
#$voltageoutputCur->write( command => "SOUR:LEV 5"); # source level point
$voltageoutputCur->write( command => "SOUR:LEV 1"); # source level point
#$voltageoutputCur->write( command => "SOUR:LEV 0"); # source level point
#$voltageoutputCur->write( command => "SOUR:LEV -1"); # source level point
#$voltageoutputCur->write( command => "SOUR:LEV 1"); # source level point


$voltageoutputCur->write( command => 'PROG:EDIT:END' );
$voltageoutputCur->set_level(value => 0);
my $t0 = time();

 
#countdown(5*60);


for my $magfield (@magfields) {
	my $folder = datafolder(path => 'IV_fast_$magfield');
	$voltageoutputMag->set_level(value=>$magfield);


	for my $temperature (@temperatures) {
	
	
	
	my $datafile = datafile(folder => $folder, filename => $temperature.'.dat',
                         columns => [qw/B T time cur voltageHi/]);
	
    say "T = $temperature";
    $lakeshore->set_T(value => $temperature);
    $voltageoutputCur->set_level(value => 0);
    #$lowmm->write(command => 'INIT');
	$highmm->write(command => 'INIT');
	$curmm->write(command => 'INIT');
    countdown($sleep_time);
	my $T_set = $lakeshore->get_T();
    # do sweep
    $voltageoutputCur->write(command => 'PROG:RUN');
    #my $datalow = $lowmm->binary_query(command => 'FETC?', read_length => $num_readings * 8 + 10, timeout => 5);
	#say "datalow: ", substr($datalow, 0, 20);
	#say length($datalow);
    #$datalow = substr($datalow, 2);
    #$datalow =~ s/\n$//;
    #my @readingslow = unpack('d>*', $datalow);
    #say "number of readings: ", (@readingslow + 0);
    #my @voltageslow = map {$_ / $voltage_gain_femto} @readingslow;
	my $datahigh = $highmm->binary_query(command => 'FETC?', read_length => $num_readings * 16 + 5, timeout => 5);
	say length($datahigh);
    $datahigh =~ s/\n$//;
    my @readingshigh = split(',', $datahigh);
    say "number of readings: ", (@readingshigh + 0);
    my @voltageshigh = map {$_/ $voltage_gain_femto } @readingshigh;
	my $datacur = $curmm->binary_query(command => 'FETC?', read_length => $num_readings * 16 + 5, timeout => 5);
	print length($datacur);
    $datacur =~ s/\n$//;
    my @readingscur = split(',', $datacur);
    say "number of readings: ", (@readingscur + 0);
    my @currents = map {$_ / $pre_resistor} @readingscur;
    $datafile->log_block(
	prefix => {B=>$magfield, T => $T_set,  time => time() - $t0},
	block => [\@currents, \@voltageshigh],
	add_newline => 1,
	);
	}



	$voltageoutputCur->set_level(value => 0);
}
